version = "2.0.1"

--Set the orientation vertical
screen.orientation(1)

--creates colors
green = color.new(0,100,0)
white = color.new(255,255,255)
black = color.new(0,0,0)
blue = color.new(0,0,100)
meterblue =  color.new(150,210,230)

sheight = screen.height()	--Saves a variable with the screen heigh for easy access
swidth = screen.width()		--Saves a variable with the screen width for easy access

--Draw loading screen
function loadingScreen(msg)
	text.size(20)
	text.color(white)
	screen.fillrect(0,0,swidth,sheight,black)
	text.draw(0,180,msg,"center",swidth)
	screen.update()
end

loadingScreen("Loading Game...")

math.randomseed(os.time())
math.random(1)

--Screen update timer setup
oldtime = os.ostime()

--Creates an array of cards to make deck of cards where you can access the value, color, card(picture or normal), image and "used" info.
cards = {{value=11,color="red",card="normal",img=image.load("cards/1h.png") ,used=false},
		 {value=2 ,color="red",card="normal",img=image.load("cards/2h.png") ,used=false},
		 {value=3 ,color="red",card="normal",img=image.load("cards/3h.png") ,used=false},
		 {value=4 ,color="red",card="normal",img=image.load("cards/4h.png") ,used=false},
		 {value=5 ,color="red",card="normal",img=image.load("cards/5h.png") ,used=false},
		 {value=6 ,color="red",card="normal",img=image.load("cards/6h.png") ,used=false},
		 {value=7 ,color="red",card="normal",img=image.load("cards/7h.png") ,used=false},
		 {value=8 ,color="red",card="normal",img=image.load("cards/8h.png") ,used=false},
		 {value=9 ,color="red",card="normal",img=image.load("cards/9h.png") ,used=false},
		 {value=10,color="red",card="normal",img=image.load("cards/10h.png"),used=false},
 		 {value=10,color="red",card="jack",img=image.load("cards/11h.png"),used=false},
		 {value=10,color="red",card="queen",img=image.load("cards/12h.png"),used=false},
		 {value=10,color="red",card="king",img=image.load("cards/13h.png"),used=false},
		 {value=11,color="black",card="normal",img=image.load("cards/1c.png") ,used=false},
		 {value=2 ,color="black",card="normal",img=image.load("cards/2c.png") ,used=false},
		 {value=3 ,color="black",card="normal",img=image.load("cards/3c.png") ,used=false},
		 {value=4 ,color="black",card="normal",img=image.load("cards/4c.png") ,used=false},
		 {value=5 ,color="black",card="normal",img=image.load("cards/5c.png") ,used=false},
		 {value=6 ,color="black",card="normal",img=image.load("cards/6c.png") ,used=false},
		 {value=7 ,color="black",card="normal",img=image.load("cards/7c.png") ,used=false},
		 {value=8 ,color="black",card="normal",img=image.load("cards/8c.png") ,used=false},
		 {value=9 ,color="black",card="normal",img=image.load("cards/9c.png") ,used=false},
		 {value=10,color="black",card="normal",img=image.load("cards/10c.png"),used=false},
 		 {value=10,color="black",card="jack",img=image.load("cards/11c.png"),used=false},
		 {value=10,color="black",card="queen",img=image.load("cards/12c.png"),used=false},
		 {value=10,color="black",card="king",img=image.load("cards/13c.png"),used=false},
		 {value=11,color="red",card="normal",img=image.load("cards/1d.png") ,used=false},
		 {value=2 ,color="red",card="normal",img=image.load("cards/2d.png") ,used=false},
		 {value=3 ,color="red",card="normal",img=image.load("cards/3d.png") ,used=false},
		 {value=4 ,color="red",card="normal",img=image.load("cards/4d.png") ,used=false},
		 {value=5 ,color="red",card="normal",img=image.load("cards/5d.png") ,used=false},
		 {value=6 ,color="red",card="normal",img=image.load("cards/6d.png") ,used=false},
		 {value=7 ,color="red",card="normal",img=image.load("cards/7d.png") ,used=false},
		 {value=8 ,color="red",card="normal",img=image.load("cards/8d.png") ,used=false},
		 {value=9 ,color="red",card="normal",img=image.load("cards/9d.png") ,used=false},
		 {value=10,color="red",card="normal",img=image.load("cards/10d.png"),used=false},
 		 {value=10,color="red",card="jack",img=image.load("cards/11d.png"),used=false},
		 {value=10,color="red",card="queen",img=image.load("cards/12d.png"),used=false},
		 {value=10,color="red",card="king",img=image.load("cards/13d.png"),used=false},
		 {value=11,color="black",card="normal",img=image.load("cards/1s.png") ,used=false},
		 {value=2 ,color="black",card="normal",img=image.load("cards/2s.png") ,used=false},
		 {value=3 ,color="black",card="normal",img=image.load("cards/3s.png") ,used=false},
		 {value=4 ,color="black",card="normal",img=image.load("cards/4s.png") ,used=false},
		 {value=5 ,color="black",card="normal",img=image.load("cards/5s.png") ,used=false},
		 {value=6 ,color="black",card="normal",img=image.load("cards/6s.png") ,used=false},
		 {value=7 ,color="black",card="normal",img=image.load("cards/7s.png") ,used=false},
		 {value=8 ,color="black",card="normal",img=image.load("cards/8s.png") ,used=false},
		 {value=9 ,color="black",card="normal",img=image.load("cards/9s.png") ,used=false},
		 {value=10,color="black",card="normal",img=image.load("cards/10s.png"),used=false},
 		 {value=10,color="black",card="jack",img=image.load("cards/11s.png"),used=false},
		 {value=10,color="black",card="queen",img=image.load("cards/12s.png"),used=false},
		 {value=10,color="black",card="king",img=image.load("cards/13s.png"),used=false} }

--Load sounds
miss = wav.load("sound/miss.wav")
press = wav.load("sound/press.wav")

--Load skin previews
dofile("skins/skins.lua")
preview = {}
--preview[1] = image.load("skins/default/preview.png")
for i=1, #skins do
	preview[i] = image.load("skins/"..skins[i].."/preview.png")
end 

--Set usable constants
cardWidth = 32
cardHeight = 50
defaultSkin = "default"

--Declare variables
playerpoints = 0
dealerpoints = 0
cash = 0
bet = 10
aces = 0
playerhand = {}		--Remembers indexes for the cards in the player's hand
dealerhand = {}		--Remembers indexes for the cards in the dealer's hand
x = 0	--Save read X-coordinates
y = 0	--Save read Y-coordinates
prompt = "Prompt"	--Stores the prompt message generated by an action
volOld = audio.volume()	--Stores the present audio when changing it
sPage = 1	--Variable to use when flipping through skin pages. 
if #skins % 2 == 1 then
  maxPage = #skins/2+0.5	--If skin is an odd number set max pages to half the amount of skins +0.5 to get a whole page
else
  maxPage = #skins/2	--If skin is an even number set max pages to half the amount of skins
end

--Remembers indexes for:
hCard = 0	--Which card is the dealer's hidden card
pHand = 0	--Where in the player's hand to place the next card
dHand = 0	--Where in the dealer's hand to place the next card

quit = false		--to check if the app should quit
startup = true		--to check if a new game just started
blackjack = true	--to determine that it is still possible to get Black Jack (Only two cards have been dealt)
stay = false		--to see if you stay, used when calculating who wins
game = false		--to see if a game is ongoing or not
ask = false			--to activate confirmation screen
settings = false	--to activate settings menu
volume = false		--to activate volume menu
promptonly = false	--to only show prompt, no cards
sound = 1			--to check if the game should have sound or not
currentSkin = defaultSkin	--To keep track of the current skin


--Read game save and settings
sSave = io.open("save/save.lua")	--Open stats file in read mode(default)
if (sSave ~= nil) then	--if it isn't empty
	input = sSave:read("*l")	--read the first line
	if (input ~= nil) then	--if input isn't empty
		cash = tonumber(input)	--convert input into a number and save as cash
	end
	input = sSave:read("*l")	--read the next line
	if (input ~= nil) then	--if input isn't empty
		sound = tonumber(input)	--convert input into a number and save in sound
	end
	input = sSave:read("*l")	--read the next line
	if (input ~= nil) then	--if input isn't empty
		currentSkin = input	--Set currentSkin to the string on the line
	end
	sSave:close()	--close file
end

	--Functions

--Saves your game
function saveStats()	
	sSave = io.open("save/save.lua","w")	--Open stats file in write mode
	if (sSave ~= nil) then	--if it isn't empty
		sSave:write(cash,"\n")	--write cash amount into it
		sSave:write(sound,"\n")	--write sound setting
		sSave:write(currentSkin,"\n")	--write skin setting
		sSave:close()	--close file
	end
end

function loadSkin(skin)
	loadingScreen("Loading Skin...")
	currentSkin = skin
	backImg = image.load("cards/back.png")
	hitbtn = image.load("skins/" .. skin .. "/hitbtn.png")
	stopbtn = image.load("skins/" .. skin .. "/stopbtn.png")
	surbtn = image.load("skins/" .. skin .. "/surbtn.png")
	betbtn = image.load("skins/" .. skin .. "/betbtn.png")
	cashdisplay = image.load("skins/" .. skin .. "/CashDisplay.png")
	display = image.load("skins/" .. skin .. "/Display.png")
	upbtn = image.load("skins/" .. skin .. "/upbtn.png")
	dwnbtn = image.load("skins/" .. skin .. "/dwnbtn.png")
	quitbtn = image.load("skins/" .. skin .. "/quitbtn.png")
	bg = image.load("skins/" .. skin .. "/bg2.png")
	lightoff = image.load("skins/" .. skin .. "/lightoff.png")
	lighton = image.load("skins/" .. skin .. "/lighton.png")
	soundonoffbtn = image.load("skins/" .. skin .. "/soundOnOffbtn.png")
	sign = image.load("skins/" .. skin .. "/sign.png")
	sign2 = image.load("skins/" .. skin .. "/sign2.png")
	sign3 = image.load("skins/" .. skin .. "/sign3.png")
	yes = image.load("skins/" .. skin .. "/yes.png")
	no = image.load("skins/" .. skin .. "/no.png")
	easy = image.load("skins/" .. skin .. "/easy.png")
	hard = image.load("skins/" .. skin .. "/hard.png")
	settingsbtn = image.load("skins/" .. skin .. "/settings.png")
	meter = image.load("skins/" .. skin .. "/meter.png")
	dot = image.load("skins/" .. skin .. "/dot.png")
	volUp = image.load("skins/" .. skin .. "/volUp.png")
	volDown = image.load("skins/" .. skin .. "/volDown.png")
	setupbtn = image.load("skins/" .. skin .. "/setupbtn.png")
	setdwnbtn = image.load("skins/" .. skin .. "/setdwnbtn.png")
end

function closeSkin()
backImg:close()
hitbtn:close()
stopbtn:close()
surbtn:close()
betbtn:close()
cashdisplay:close()
display:close()
upbtn:close()
dwnbtn:close()
quitbtn:close()
bg:close()
lighton:close()
lightoff:close()
soundonoffbtn:close()
sign:close()
sign2:close()
yes:close()
no:close()
easy:close()
hard:close()
miss:close()
press:close()
settingsbtn:close()
setupbtn:close()
setdwnbtn:close()
end

--Places everything in its place on the screen
function drawScreen()	
--newtime = os.ostime()
  -- if (newtime - oldtime) > 36 then
   --oldtime = os.ostime()	
	screen.fillrect(0,0,swidth,sheight,green)	--draw green background
	
	--Draw background, buttons and stuff (Always)
	text.size(18)
	text.color(green)
	display:draw(110,310,100,30)	--Displays drawn first so they will be seen through the background
	text.draw(132,315,bet,"left")
	cashdisplay:draw(10,360,200,30)
	text.draw(33,365,cash,"left")
	
	bg:draw(0,0,240,400)
	
	if (game == false) then	--if game is not ongoing
		lightoff:draw(206,310,30,30)	--draw a switched off light
		if(startup==false) then	--and startup is false (have returned form a game)
			text.color(blue)
			text.draw(0,130,prompt,"center", 240)	--draw prompt message
		end
	else	--game is ongoing
		lighton:draw(206,310,30,30)		--draw switched on light
	end
	hitbtn:draw(10,250,50,50)
	stopbtn:draw(60,250,50,50)
	surbtn:draw(110,250,50,50)
	betbtn:draw(60,300,50,50)
	upbtn:draw(170,290,40,20)
	dwnbtn:draw(170,340,40,20)
	settingsbtn:draw(213,365,20,20)
	
	if(cash<=0 and game==false) then	--If player is bancrupt
		text.size(18)
		text.color(white)
		text.draw(10,10,"Black Jack ." .. version,"center",230)
		text.draw(10,54," :","center",230)
		easy:draw(15,75,100,50)	--draw easy and hard options
		hard:draw(125,75,100,50)
		text.size(14)
		text.draw(10,226,"by Habhome","left")
	elseif(startup == true) then	--Draws out info if the game just started
		text.size(18)
		text.color(white)
		text.draw(10,10,"Black Jack ." .. version,"center",230)
		text.size(14)
		text.draw(12,26,"   21 ","left")
		text.draw(12,40,"   ","left")
		text.draw(12,54," :","left")
		text.draw(12,68,"1.  ","left")
		text.draw(12,82,"2. ","left")
		text.draw(12,96,"3. ","left")
		text.draw(12,110,"4.  ","left")
		text.draw(12,124," -  ","left")
		text.draw(12,138," -    ","left")
		text.draw(12,152,"  Home  ","left")
		text.draw(12,166,"    ","left")
		text.draw(10,226,"by Habhome","left")
		
	elseif(promptonly == false) then	--After startup draw cards if not only prompt should be visible
		--Draw out dealer's hand & score
		backImg:draw((10+cardWidth*1), 20, cardWidth, cardHeight)	--And a face-down card in the position where the second would be (Always draws out, if there is an unhidden card it will cover this image)
		if(game == true) then	--While the player haven't stayed
			for i = 0, dHand-1 do	
				cards[dealerhand[i]].img:draw((10+cardWidth*i), 20, cardWidth, cardHeight)	--Draw out the first card in the dealer's hand, increases the X coordinate with the card's width every time so they won't overlap
			end	
		else	--If the player have stayed and the dealer have taken his turn
			for i = 0, dHand-1 do
				cards[dealerhand[i]].img:draw((10+cardWidth*i), 20, cardWidth, cardHeight)	--Draw out all cards in the dealer's hand, increases the X coordinate with the card's width every time so they won't overlap
			end
		end
		text.size(18)
		text.color(white)
		text.draw(10,75,":     " .. dealerpoints,"left")	--Draws out the dealer's score
		
		for i = 0, pHand-1 do
				cards[playerhand[i]].img:draw((10+cardWidth*i), 160, cardWidth, cardHeight)	--Draw out all cards in the player's hand, increases the X coordinate with the card's width every time so they won't overlap
		end
		text.size(18)
		text.color(white)
		text.draw(10,215,":     " .. playerpoints,"left")	--Draws out the player's score
	end
	
	if(settings == true) then
		sign2:draw(20,25,211,225)	--draw signboard2
		quitbtn:draw(194,30,20,20)	--draw exit button in upper right
		soundonoffbtn:draw(40,45,100,40)	--draw sound on/off button
		if (sound == 1) then
			lighton:draw(150,50,30,30)	--Draw active light if sound is active
		elseif (sound == 0) then
			lightoff:draw(150,50,30,30)	--Draw inactive light if sound is muted
		end
		text.color(white)
		preview[sPage*2-1]:draw(40,110,100,50)	--Draw top preview on page "sPage". There are 2 on each page therefore the top one is the page nr times two minus one
		text.draw(145,125,skins[sPage*2-1])	--Draw the corresponding text to the top preview right to it.
		if (#skins % 2 == 1) then	--If skin is odd number...
			if (sPage < maxPage) then	--Only draw bottom preview if it isn't the last page of skins
				preview[sPage*2]:draw(40,163,100,50)	--Draw bottom preview on page "sPage". There are 2 on each page so it its simply the page number times two
				text.draw(145,178,skins[sPage*2])	--Draw the corresponding text to the bottom preview right to it.
			end
		else	--Always do if skin is even number
			preview[sPage*2]:draw(40,163,100,50)	--Draw bottom preview on page "sPage". There are 2 on each page so it its simply the page number times two
			text.draw(145,178,skins[sPage*2])	--Draw the corresponding text to the bottom preview right to it.
		end
		if (sPage ~= 1) then
			setupbtn:draw(110,90,20,20)
		end
		if (sPage < maxPage) then
			setdwnbtn:draw(110,213,20,20)
		end
	end
	
	if(volume == true) then
		sign3:draw(20,25,211,350)	--draw signboard3
		quitbtn:draw(194,30,20,20)	--draw exit button in upper right
		text.size(20)
		text.color(white)
		text.draw(112,205,audio.volume(),"left")	--Draw current volume level
		volUp:draw(100,150,50,50)
		volDown:draw(100,230,50,50)
		text.size(14)
		text.draw(75,40," :","left")

		if(audio.volume() > 0) then	--if volume is over 0
			dot:draw(48,320,20,20)	--fill lower part of the meter
			screen.fillrect(53,327-11*audio.volume()+11,12,11*audio.volume()-11,meterblue)
		end
		if(audio.volume() == 25) then	--if volume is 25
			dot:draw(48,45,20,20)	--fill upper part of the meter
		end
		meter:draw(40,35,40,312)	--draw volume meter
	end
	
	if(ask == true) then	--If there should be a confirmation screen
		sign:draw(20,100,211,111)	--draw signboard
		text.color(white)
		text.draw(20,108,prompt,"center",220)	--draw prompt message
		yes:draw(45,142,50,50)	--draw yes and no buttons
		no:draw(146,142,50,50)
	end

	screen.update()
 -- end
end

--Increases volume
function volPlus()
	volOld = audio.volume()
	if(volOld < 25) then
		audio.volume(volOld + 1)
		if (sound == 1) then	--If not muted
			press:play()	--Play button sound
		end
	else
		if (sound == 1) then	--If not muted
			miss:play()	--Play miss sound
		end
	end
end

--Decreases volume
function volMinus()
	volOld = audio.volume()
	if(volOld > 0) then
		audio.volume(volOld - 1)
		if (sound == 1) then	--If not muted
			press:play()	--Play button sound
		end
	else
		if (sound == 1) then	--If not muted
			miss:play()	--Play miss sound
		end
	end
end

--Returns the index of a random unused card
function getRandomCard()	
	index = math.random(52)	--get a random index of 1-52
	while(cards[index].used == true) do	--while that index points at a used card
		index = math.random(52)	--get a new index
	end
	cards[index].used = true	--when unused card is found, set it as used
	return index;	--return index of the chosen card
end 

--Checks who wins
function checkForWin()
	if (playerpoints>21) then	--if you exceed 21 points you lose
		prompt = " , ..."	--Set prompt message
		game = false	--Game is finished
	elseif(playerpoints==21 and blackjack==true) then	--if you've got 21 points and chance to Black Jack...
		dealerTurn()						--...the dealer takes its turn, but only opens its hidden card			
		if(dealerpoints==21) then					--if the dealer get's 21 with that it's a tie
			prompt = "Black Jack "	--set prompt message
			cash = cash + bet	--Gives back your bet due to being a tie
			game = false	--Game is finished
		else					--if the dealer doesn't get 21, you win
			prompt = "   Black Jack!"	--set prompt message
			cash = cash + bet*2.5	--Give back x2 your bet
			game = false	--Game is finished
		end
	elseif(playerpoints==21) then			--if you have 21 but not Black Jack...
		dealerTurn()						--...dealer's turn...
		if(dealerpoints==21 and dHand==1) then			--... if he get's Black Jack you lose
			prompt = " !"	--set prompt message
			game = false	--Game is finished
		elseif(dealerpoints==21) then			--... if he get's 21 it's a tie
			prompt = ""	--set prompt message
			cash = cash + bet	--Give back your bet
			game = false	--Game is finished
		else								-- Otherwise it's a win
			prompt = " !"	--set prompt message
			cash = cash + bet*2	--Give back twice your bet
			game = false	--Game is finished
		end
	elseif(playerpoints<21 and stay==true) then	--if you instead have less than 21 but stays (Stay always let the dealer draw cards before)...
		if(dealerpoints<playerpoints) then		--...and the dealer have less points than you, you win
			prompt = " !"	--set prompt message
			cash = cash + bet*2	--Give back twice your bet
			game = false	--Game is finished
		elseif(dealerpoints>playerpoints and dealerpoints<=21) then	--if the dealer have more than you but still not over 21, you lose
			prompt = " !"	--set prompt message
			game = false	--Game is finished
		elseif(dealerpoints>21) then				--if you've stayed and the dealer exceeds 21, you win
			prompt = " !"	--set prompt message
			cash = cash + bet*2	--Give back twice your bet
			game = false	--Game is finished
		elseif(dealerpoints==playerpoints) then	--if you've stayed and the dealer get's the same score, it's a tie
			prompt = "!"	--set prompt message
			cash = cash + bet	--Give back your bet
			game = false	--Game is finished
		end
	end
end

--Check when there is a move
function checkMove(x,y)
	if(volume == true) then
		if((x>=50) and (x<=90) and (y>=35) and (y<=347)) then
			if((y>=340) and (y<=347)) then
				audio.volume(0)
			elseif((y>=329) and (y<=339)) then
				audio.volume(0)
			elseif((y>=318) and (y<=328)) then
				audio.volume(1)
			elseif((y>=307) and (y<=317)) then
				audio.volume(2)
			elseif((y>=296) and (y<=306)) then
				audio.volume(3)
			elseif((y>=285) and (y<=295)) then
				audio.volume(4)
			elseif((y>=274) and (y<=284)) then
				audio.volume(5)
			elseif((y>=263) and (y<=273)) then
				audio.volume(6)
			elseif((y>=252) and (y<=262)) then
				audio.volume(7)
			elseif((y>=241) and (y<=251)) then
				audio.volume(8)
			elseif((y>=230) and (y<=240)) then
				audio.volume(9)
			elseif((y>=219) and (y<=229)) then
				audio.volume(10)
			elseif((y>=208) and (y<=218)) then
				audio.volume(11)
			elseif((y>=197) and (y<=207)) then
				audio.volume(12)
			elseif((y>=186) and (y<=196)) then
				audio.volume(13)
			elseif((y>=175) and (y<=185)) then
				audio.volume(14)
			elseif((y>=164) and (y<=174)) then
				audio.volume(15)
			elseif((y>=153) and (y<=163)) then
				audio.volume(16)
			elseif((y>=142) and (y<=152)) then
				audio.volume(17)
			elseif((y>=131) and (y<=141)) then
				audio.volume(18)
			elseif((y>=120) and (y<=130)) then
				audio.volume(19)
			elseif((y>=109) and (y<=119)) then
				audio.volume(20)
			elseif((y>=98) and (y<=108)) then
				audio.volume(21)
			elseif((y>=87) and (y<=97)) then
				audio.volume(22)
			elseif((y>=76) and (y<=86)) then
				audio.volume(23)
			elseif((y>=65) and (y<=75)) then
				audio.volume(24)
			elseif((y>=50) and (y<=64)) then
				audio.volume(25)
			end
		end
	end
end

--Acts after where you have pressed
function checkClick(x,y)
	if ((x>=213) and (x<=233) and (y>=365) and (y<=385)) then	--if settings is pressed
		settings = true	--Activate settings screen
		if (sound == 1) then	--If not muted
			press:play()	--Play button sound
		end
	end
	
	if(ask == true) then	--If a confirmation screen is up
		if ((x>=45) and (x<=95) and (y>=142) and (y<=192)) then	--yes is pressed
			if(prompt == "?") then	--if the question is "Quit?"
				quit = true	--Quit
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			elseif(prompt == "?") then	--if the question is "Surrender?"
				cash = cash + bet/2	--Give back half your bet
				prompt = " ."	--set prompt to diplay and confirm that you have surrendered
				game = false	--Stop the ongoing game
				ask = false		--Remove confirmation screen
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			end
		elseif ((x>=146) and (x<=196) and (y>=142) and (y<=192)) then	--no is pressed
			ask = false	--set false to remove confirmation window
			prompt = "Addicted, ey? ;)"
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
		end
	elseif(volume == true) then	--if volume screen is up
		if ((x>=194) and (x<=214) and (y>=30) and (y<=50)) then	--If X is pressed
			volume = false
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
		elseif (math.sqrt((math.abs(x-125)*math.abs(x-125))+(math.abs(y-175)*math.abs(y-175)))<19) then	--if vol+ is pressed
			volPlus()
		elseif (math.sqrt((math.abs(x-125)*math.abs(x-125))+(math.abs(y-255)*math.abs(y-255)))<19) then	--if vol- is pressed
			volMinus()
		end
	elseif(settings == true) then	--If settings screen is up
		if ((x>=194) and (x<=214) and (y>=30) and (y<=50)) then	--If X is pressed
			settings = false
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
		elseif ((x>=40) and (x<=140) and (y>=45) and (y<=85)) then	--if sound on/off is pressed
			if (sound == 1) then
				sound = 0
			else
				sound = 1
				press:play()	--Play button sound
			end
		elseif ((x>=110) and (x<=130) and (y>=90) and (y<=110)) then	--if settings up is pressed
			if (sPage ~= 1) then	--If the current page isn't 1
				setupbtn:draw(110,90,20,20)	--Draw up button twice above the already existing one to make it more visible (transpareny adding up)
				setupbtn:draw(110,90,20,20)
				screen.update()	--Update screen to show it
				os.wait(25)	--Wait a little while so it's visible
				sPage = sPage-1	--Decrease page number
			end
		elseif ((x>=40) and (x<=140) and (y>=110) and (y<=160)) then	--if top skin is pressed
			closeSkin()	--Close current skin
			loadSkin(skins[sPage*2-1])	--Open corresponding skin to this place in the skin list
		elseif ((x>=40) and (x<=140) and (y>=163) and (y<=213)) then	--if bottom skin is pressed
			if (#skins % 2 == 1) then	--If skin is odd number...
				if (sPage < maxPage) then	--Only select if it isn't the last page of skins
					closeSkin()	--Close current skin
					loadSkin(skins[sPage*2])	--Open corresponding skin to this place in the skin list
				end
			else	--Always do if skin is even number
				closeSkin()	--Close current skin
				loadSkin(skins[sPage*2])	--Open corresponding skin to this place in the skin list
			end	
		elseif ((x>=110) and (x<=130) and (y>=213) and (y<=233)) then	--if settings down is pressed
			if (sPage < maxPage) then	--If the curent page isn't the last
				setdwnbtn:draw(110,213,20,20)	--Draw down button twice above the already existing one to make it more visible (transpareny adding up)
				setdwnbtn:draw(110,213,20,20)
				screen.update()	--Update screen to show it
				os.wait(25)	--Wait a little while so it's visible
				sPage = sPage+1	--Increase page number
			end
		end
	elseif(cash<=0 and game==false) then	--If player is bancrupt
		if ((x>=15) and (x<=115) and (y>=75) and (y<=125)) then	--easy is pressed
			cash = 500
			startup = true
			bet = 10
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
		elseif ((x>=125) and (x<=225) and (y>=75) and (y<=125)) then	--hard is pressed
			cash = 100
			startup = true
			bet = 10
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
		else
			if (sound == 1) then	--If not muted
				miss:play()	--Play miss sound
			end
		end
	elseif(game == false) then	--if a game is not currently ongoing
		if ((x>=170) and (x<=210) and (y>=290) and (y<=310)) then	--if up arrow is pressed
			if(bet>=cash) then	--if bet is equal to or more than your cash
				if(bet==cash) then	--if it is equal to
					if (sound == 1) then	--If not muted
						miss:play()	--Play miss sound
					end
				else	--if more than
					bet = cash	-- it is evened out to your cash amount
					if (sound == 1) then	--If not muted
						miss:play()	--Play miss sound
					end
				end
			end
			if(bet<1000 and bet<cash) then	--if bet is below 1000
				bet = bet + 10	--increase with 10
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			elseif(bet>=1000 and bet<10000 and bet<cash) then	--if bet is above or equal to 1000 but less than 10000
				bet = bet + 100	--increase with 100
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			elseif(bet>=10000 and bet<cash) then	--if bet is above or equal to 10000
				bet = bet + 1000	--increase with 1000
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			end
		elseif ((x>=170) and (x<=210) and (y>=340) and (y<=360)) then	--if down arrow is pressed
			if(bet<=10) then	--if bet is equal to or lower than 10
				if(cash<bet) then	--if cash is lower than lowest bet
					bet = cash	-- bet is evened out to your cash amount
					if (sound == 1) then	--If not muted
						press:play()	--Play button sound
					end
				else
					if (sound == 1) then
						miss:play()	--Play miss sound
					end
				end
			end
			if(bet<=1000 and bet>10) then	--if bet is below or equal to 1000 but not as low as 10
				bet = bet - 10	--decrease with 10
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			elseif(bet>1000 and bet<=10000) then	--if bet is over 1000 but less than or equal to 10000
				bet = bet - 100	--decrease with 100
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			elseif(bet>10000) then	--if bet is above 10000
				bet = bet - 1000	--decrease with 1000
				if (sound == 1) then	--If not muted
					press:play()	--Play button sound
				end
			end
		elseif (math.sqrt((math.abs(x-85)*math.abs(x-85))+(math.abs(y-325)*math.abs(y-325)))<19) then	--if bet is pressed
			startup = false	--No longer just started
			if(bet>cash) then
				promptonly = true
				prompt = "  !"
				if (sound == 1) then	--If not muted
					miss:play()	--Play miss sound
				end
			else
			promptonly = false
			game = true	--game is ongoing
			cash = cash-bet	--temporarily remove bet from cash
			createGame()	--Deal new game
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
			end
		else
			if (sound == 1) then	--If not muted
				miss:play()	--Play miss sound
			end
		end
	else	--If game is ongoing and no confirmation screen is up
		if (math.sqrt((math.abs(x-35)*math.abs(x-35))+(math.abs(y-275)*math.abs(y-275)))<19) then	--if hit is pressed
			blackjack = false
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
			playerhand[pHand] = getRandomCard()	--Add a random unused card to the player's hand
			pHand = pHand+1	--Increase pos where to place the next, and for score
			playerPoints()	--Calculate score
		elseif (math.sqrt((math.abs(x-85)*math.abs(x-85))+(math.abs(y-275)*math.abs(y-275)))<19) then	--if stay is pressed
			blackjack = false
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
			stay = true	--Set stay as true
			dealerTurn()	--let the dealer draw
			checkForWin()	--Check to see if the player win
		elseif (math.sqrt((math.abs(x-135)*math.abs(x-135))+(math.abs(y-275)*math.abs(y-275)))<19) then	--if surrender is pressed
			ask = true	--Activate confirmation question
			prompt = "?"	--Set prompt message
			if (sound == 1) then	--If not muted
				press:play()	--Play button sound
			end
		else
			if (sound == 1) then	--If not muted
				miss:play()	--Play miss sound
			end
		end
	end
end

--Calculates the player's score
function playerPoints()
	playerpoints = 0	--Reset score to prevent it from adding to the previous calculation
	for i = 0, pHand-1 do
			playerpoints = playerpoints + cards[playerhand[i]].value	--Adds the value of the card in position i of the player's hand to his score
	end
	if (playerpoints>21) then	--If the score exceeds 21
		playerpoints = checkForAces(playerhand, playerpoints, pHand)	--Check for possible aces which can be counted as 1
	end
	checkForWin()	--Check if the player wins or not
end

--Calculates the dealer's score
function dealerPoints()
	dealerpoints = 0
	if(game == true) then	--While the player haven't stayed
		for i = 0, dHand-1 do	
			dealerpoints = dealerpoints + cards[dealerhand[i]].value
		end	
	else	--If the player have stayed and the dealer have taken his turn
		for i = 0, dHand-1 do
			dealerpoints = dealerpoints + cards[dealerhand[i]].value	--Adds the value of the card in position i of the dealer's hand to his score
		end
	end
	if (dealerpoints>21) then	--If the score exceeds 21
		dealerpoints = checkForAces(dealerhand, dealerpoints, dHand)	--Check for possible aces which can be counted as 1
	end
end

--Allows for the dealer to draw cards
function dealerTurn()
	if(blackjack == true) then	--if the player got black jack the dealer can only flip his hidden card
		dealerhand[1] = hCard	--Adds the hidden card to the dealer's hand
		dHand = dHand+1			--add 1 to where in the hand to place the card to use in score calc
		dealerPoints()
	else	--if the player just stayed
		dealerhand[1] = hCard	--Adds the hidden card to the dealer's hand
		dHand = dHand+1			--add 1 to where in the hand to place the card to use in score calc
		dealerPoints()			--Check the dealer's score to see if he should hit
		while(dealerpoints<17) do	--As long as the dealer haven't reached 17
			dealerhand[dHand] = getRandomCard()	--Take another random unused card
			dHand = dHand+1	--add to where to place the next card, also for score calc
			dealerPoints()	--Calculate score to see if dealer should contintue
		end		
	end
end

--Check if there are any aces in the hand if the points exceed 21
function checkForAces(hand, points, length)
	aces = 0	--reset number of aces in the hand
	
	for i = 0, length-1 do	--check the entire hand
		if(cards[hand[i]].value == 11) then	--if card is an ace
			aces = aces + 1	--add 1 to # of aces
		end
	end
	
	if (aces == 1) then	--if one ace is in the hand
		return (points-10)	--count it as one by removing 10 from the score
	elseif (aces == 2) then	--if two aces are in the hand
		points = points - 22		--remove 22 points to know the other cards' value
		if((points+12)<=21) then	--if one ace is counted as one and the other as eleven and it is still not exceeding 21...
			return (points+12)	--...use that score by adding 12 to the score
		else		--if it does exceed 21...
			return (points+2)	--...count both as one by adding 2
		end
	elseif (aces == 3) then	--if three aces are in the hand
		points = points-33		--remove 33 points to know the other cards' value
		if((points+13)<=21) then	--if two aces is counted as one and the third as eleven and it is still not exceeding 21...
			return (points+13)	--...use that score by adding 13 to the score
		else				--if it does exceed 21...
			return (points+3)	--...count them all as one by adding three
		end
	elseif (aces == 4) then	--if four aces are in the hand
		points=points-44		--remove 44 points to know the other cards' value
		if((points+14<=21)) then	--if three aces is counted as one and the fourth as eleven and it is still not exceeding 21...
			return (points+14)	--...use that score by adding 14 to the score
		else			--if it does exceed 21...
			return (points+4)	--...count them all as one by adding four
		end
	else	--if there are no aces...
		return points	--...confirm the initial score
	end	
end

--Deals a new game
function createGame()	
	startup = false	--Game is no longer "just started"
	
	--Reset variables
	pHand = 0	--Reset index of where to place the next card in the player's hand
	dHand = 0	--Reset index of where to place the next card in the dealer's hand
	for i = 1, 52 do	--For all 52 cards
		cards[i].used = false	--Set as unused
	end
	playerpoints = 0	--Reset player's points
	dealerpoints = 0	--Reset dealer's points
	blackjack = true;	--reset Black Jack possibility state as still possible
	stay = false;		--reset stay state
	
	--Deals to the dealer
	dealerhand[dHand] = getRandomCard()	--Gives the dealer a random unused card
	dHand = dHand+1	--Increases the position where to place the next card in the dealer's hand
	hCard = getRandomCard()	--Remember the hidden card of the dealer, is drawn out without being added to the dealer's hand
	dealerPoints()	--Calculate the score of the dealer
	
	--Deals to the player
	for i = 0, 1 do	--To deal two cards
		playerhand[pHand] = getRandomCard()	--Give the player a random unused card
		pHand = pHand+1	--Increases the position where to place the next card in the player's hand
	end
	playerPoints()	--Calculate the score of the player
	
end

--Program start

--Loads skin
loadSkin(currentSkin)

-- Main loop
while (1) do
	for i = 0, 10 do
		if (control.read()==1) then
			if (control.isTouch()==1) then
				x,y = touch.pos()
				if (touch.click() == 1) then
					checkClick(x,y)
				elseif(touch.move() == 1) then
					checkMove(x,y)
				end
			elseif (control.isButton()==1) then
				if button.click() == 1 then
					ask = true	--Activate settings screen
					prompt = "?"	--Set prompt message
					if (sound == true) then	--If not muted
						press:play()	--Play button sound
					end
				elseif (button.hold() ==1) then
					volume = true	--activate volume menu
					if (sound == true) then	--If not muted
						press:play()	--Play button sound
					end
				end
			end
		end
	end
	if (quit == true) then
		os.wait(500)
		break
	end
	drawScreen()
	os.sleep(1)
end

--Fill screen with black to prevent screen from going glitchy while changing orientation
screen.fillrect(0,0,swidth,sheight,black)
screen.update()

saveStats()	--Save your cash when you exit the app

--close resources
closeSkin()

for i = 1, #preview do
	preview[i]:close()
end
for i = 1, 52 do
	cards[i].img:close()
end

miss:close()
press:close()

--reset screen orientation to horizontal 
screen.orientation(0)